; Author: Petroizki

.686
.mmx
.k3d
.model flat, stdcall
	include windows.inc
	
	include gdi32.inc
	include kernel32.inc
	include masm32.inc
	include user32.inc
	
	includelib gdi32.lib
	includelib kernel32.lib
	includelib masm32.lib
	includelib user32.lib
	
	REFRESH_WAIT EQU <33>	; time waited before refreshing dots
	SCREEN_HEIGHT EQU <480>	; window height
	SCREEN_WIDTH EQU <640> 	; window width
	
	include dots_3dnow.inc
	
	WndProc proto :HWND, :UINT, :WPARAM, :LPARAM
.data
	STRING_WINCLASS db "FLOCKING",0
	STRING_WINNAME db "Dot Flocking Behaviour",0

	g_mousepos MATRIX2x1 <-666.0, -666.0>
	g_winclass WNDCLASSEX <SIZEOF WNDCLASSEX, CS_HREDRAW or CS_VREDRAW, WndProc, 0, 0, NULL, NULL, NULL, \
		NULL, NULL, OFFSET STRING_WINCLASS, NULL>
.data?
	g_msg MSG <?>
	g_rect RECT <?>
.code
start:
	invoke GetStockObject, BLACK_BRUSH		; get background brush
	mov dword ptr [g_winclass.hbrBackground], eax
	invoke LoadCursor, NULL, IDC_ARROW		; get desktop cursor
	mov dword ptr [g_winclass.hCursor], eax
	invoke GetModuleHandle, NULL			; get process module handle
	mov dword ptr [g_winclass.hInstance], eax
	
	invoke RegisterClassEx, ADDR g_winclass	; register windowclass
	test eax, eax
	jz @force_exit							; fuck it
	
	invoke CreateWindowEx, 0, ADDR STRING_WINCLASS, ADDR STRING_WINNAME, WS_MINIMIZEBOX or WS_SYSMENU or WS_VISIBLE, \
		15, 20, SCREEN_WIDTH, SCREEN_HEIGHT, NULL, NULL, g_winclass.hInstance, NULL
	test eax, eax
	jz @force_exit							; terminate prog, it would be nice to have some error messages, but who cares
	
	mov ebx, eax							; store the window handle
	assume ebx:HWND
	
	invoke GetDC, eax						; get window DC
	mov edi, eax
	assume edi:HDC
	
	invoke GetClientRect, ebx, ADDR g_rect	; get window rectangle
	
	invoke CreateDots, ADDR g_rect			; initialize dots, colors, positions and world size
	
	invoke GetTickCount						; get current time
	lea esi, [eax + REFRESH_WAIT]			; get time when dots are to refreshed next
	
@main_loop:
	invoke PeekMessage, ADDR g_msg, NULL, 0, 0, PM_REMOVE
	test eax, eax
	.IF !zero?
		cmp dword ptr [g_msg.message], WM_QUIT
		je @end_main_loop					; quit loop if quit message was encountered
		
		invoke TranslateMessage, ADDR g_msg
		invoke DispatchMessage, ADDR g_msg
	.ENDIF
	
	invoke GetTickCount
	cmp eax, esi
	jb @main_loop
	
	lea esi, [eax + REFRESH_WAIT]
	
	invoke FillRect, edi, ADDR g_rect, g_winclass.hbrBackground ; flush background
	invoke UpdateWorld, edi					; update dot positions and draw dots
	invoke RunAI, g_mousepos.x, g_mousepos.y; run A.I.
	jmp @main_loop
@end_main_loop:
	invoke ReleaseDC, ebx, edi				; release dc..
	assume ebx:nothing
	assume edi:nothing
@force_exit:
	invoke ExitProcess, 0					; exit program
	
WndProc proc, hWnd:HWND, Msg:UINT, wParam:WPARAM, lParam:LPARAM
	cmp Msg, WM_DESTROY						; if window want's to die
	je @WM_DESTROY
	
	cmp Msg, WM_MOUSEMOVE					; check mouse position
	je @WM_MOUSEMOVE
	
	invoke DefWindowProc, hWnd, Msg, wParam, lParam	; jump to def proc
	ret
@WM_DESTROY:
	invoke PostQuitMessage, 0
	xor eax, eax
	ret
@WM_MOUSEMOVE:
	fild word ptr [lParam]					; get x pos (LOWWORD lParam)
	fstp dword ptr [g_mousepos.x]			; store it
	
	fild word ptr [(lParam) + 2]			; get y pos (HIGHWORD lParam)
	fstp dword ptr [g_mousepos.y]			; store it too
	ret
WndProc endp
end start